require( "mIRC_Interface" )


local wndgIRC		= nil

// Lists
lstChannels	= nil
lstChat		= nil
lstUsers	= nil

// Record!
local iLastChan = 1
local iLastNet = 1
local iLineCount = 0
local iLastUserCount = 0

local function gIRC_UpdateTitle()
	if(wndgIRC != nil) then
		local szWindowTitle = "gIRC - " .. gIRC.GetNetName( iLastNet ) .. " - " .. gIRC.GetChannelName( iLastNet, iLastChan )
		wndgIRC:SetTitle( szWindowTitle )
	end
end



local function gIRC_UpdateUserList( full_update )
	
	local iUsers = gIRC.GetTotalUsers( iLastNet, iLastChan )
		if(iUsers != iLastUserCount || full_update ) then
		
		lstUsers:Clear()
		
		for numuser=1, iUsers, 1 do
			lstUsers:AddLine(gIRC.GetUserName(iLastNet, iLastChan, numuser))
		end
		iLastUserCount = iUsers
	end
end

local function gIRC_UpdateChat( full_update )
	if( full_update ) then
		iLineCount = 0
		lstLines:Clear()
	end
	local iCurLines = gIRC.GetTotalLines(iLastNet, iLastChan)
	
	if( iCurLines > iLineCount ) then
		local itemp = iLineCount + 1
		for linenum=itemp, iCurLines, 1 do
			lstLines:AddLine(gIRC.GetLine(iLastNet,iLastChan, linenum))
		end
		iLineCount = iCurLines
		
		lstLines.VBar:SetScroll( (iLineCount * 2) * 16)
	end
	lstLines.VBar:SetScroll( (iLineCount * 2) * 16)
	
end

local function gIRC_UpdateChannelList( )
lstChannels:Clear()
local ndNets = {}
		for netnum=1, gIRC.GetTotalNets(), 1 do
			ndNets[netnum] = lstChannels:AddNode(gIRC.GetNetName(netnum))
			ndNets[netnum].ndChans = {}
			// Add nodes!
			for channum=1, gIRC.GetTotalChannels(netnum), 1 do
				local chan = ndNets[netnum]:AddNode( "#" ..gIRC.GetChannelName(netnum, channum))
				chan.DoClick = function()
					ndNets[netnum].ndChans.net = netnum
					ndNets[netnum].ndChans.chan = channum
					iLastNet = ndNets[netnum].ndChans.net
					iLastChan = ndNets[netnum].ndChans.chan
					lstUsers:Clear()
					lstLines:Clear()
					iLineCount = 0
					gIRC_UpdateChat( true )
					gIRC_UpdateUserList( true )
				end
			end
			ndNets[netnum]:ExpandRecurse(true)
		end
end

local function TimedgIRCUpdate()
if(wndgIRC != nil ) then
	if(wndgIRC:IsVisible()) then
		gIRC_UpdateUserList( false )
		gIRC_UpdateChat( false )
		gIRC_UpdateTitle()
	end
end
end

local function StartgIRC()
	wndgIRC = vgui.Create( "DFrame" )
	wndgIRC:SetSize( ScrW() - 50, ScrH() - 50 )
	wndgIRC:Center()
	wndgIRC:SetDeleteOnClose(true)
	wndgIRC.btnClose.DoClick = function ( button ) 
		iLineCount = 1
		wndgIRC:Close() 
	end

	gIRC.SetupInterface()
	gIRC_UpdateTitle()
	
	lstChannels = vgui.Create( "DTree", wndgIRC )
	lstLines = vgui.Create( "DListView", wndgIRC )
	local divChan = vgui.Create( "DHorizontalDivider", wndgIRC )
	divChan:SetSize( wndgIRC:GetWide() - 170, wndgIRC:GetTall() - 75 )
	divChan:SetPos( 15, 30 )
	divChan:SetLeft( lstChannels )
	divChan:SetRight( lstLines )
	divChan:SetLeftWidth( 150 )
	
	lstChannels:SetSize( 150, wndgIRC:GetTall() - 50 )
	lstChannels:SetPos( 15, 35 )
	gIRC_UpdateChannelList()

	lstLines:SetMultiSelect(false)
	lstLines:SetSize( wndgIRC:GetWide() - 350, wndgIRC:GetTall() - 70 )
	lstLines:SetPos( 170, 35 )
	lstLines:AddColumn("Chat")
	// This can suck!
	gIRC_UpdateChat()
	lstLines.VBar:SetScroll( (iLineCount * 2) * 16 )
	
	
	lstUsers = vgui.Create( "DListView", wndgIRC )
	lstUsers:SetMultiSelect(false)
	lstUsers:SetSize( 135, wndgIRC:GetTall() - 40 )
	lstUsers:SetPos( wndgIRC:GetWide() - 150, 30 )
	lstUsers:AddColumn("Users")
	gIRC_UpdateUserList(true)
	

	local divUsers = vgui.Create( "DHorizontalDivider", wndgIRC )
	divUsers:SetSize( wndgIRC:GetWide() - 30, wndgIRC:GetTall() - 70 )
	divUsers:SetPos( 15, 30 )
	divUsers:SetLeft( divChan )
	divUsers:SetRight( lstUsers )
	divUsers:SetLeftWidth(wndgIRC:GetWide() - 145)
	
	local function recreate_input()
		local txtInput = vgui.Create( "DTextEntry", wndgIRC )
		txtInput:SetSize( wndgIRC:GetWide() - 30, 22 )
		txtInput:SetPos( 15, wndgIRC:GetTall() - 32 )
		txtInput.OnEnter = function()
			gIRC.SendTextToChannel(iLastNet, iLastChan, txtInput:GetValue() )
			txtInput:Remove()
			recreate_input()
		end
		txtInput:RequestFocus()
	end
	recreate_input()
	
	wndgIRC:MakePopup()
	wndgIRC:SetMouseInputEnabled(true)
	wndgIRC:SetKeyBoardInputEnabled(true)
	
	timer.Create( "gircUpdate", 0.2, 0, TimedgIRCUpdate )
	
end
concommand.Add( "girc", StartgIRC )
